/**
 * 
 */
package ch.psi.daq.queryrest.controller;

import java.util.LinkedHashSet;
import java.util.LinkedList;
import java.util.Set;

import javax.annotation.Resource;

import org.springframework.validation.Errors;
import org.springframework.validation.Validator;

import ch.psi.daq.query.model.AbstractQuery;
import ch.psi.daq.query.model.Aggregation;
import ch.psi.daq.query.model.QueryField;
import ch.psi.daq.queryrest.config.QueryRestConfig;

/**
 * @author zellweger_c
 *
 */
public class QueryValidator implements Validator {

   @Resource(name = QueryRestConfig.BEAN_NAME_DEFAULT_RESPONSE_FIELDS)
   private Set<QueryField> defaultResponseFields;

   @Resource(name = QueryRestConfig.BEAN_NAME_DEFAULT_RESPONSE_AGGREGATIONS)
   private Set<Aggregation> defaultResponseAggregations;

   /**
    * {@inheritDoc}
    */
   @Override
   public boolean supports(Class<?> clazz) {
      return AbstractQuery.class.isAssignableFrom(clazz);
   }

   /**
    * {@inheritDoc}
    */
   @Override
   public void validate(Object target, Errors errors) {

      AbstractQuery query = (AbstractQuery) target;

      if (query.getFields() == null || query.getFields().isEmpty()) {
         query.setFields(new LinkedHashSet<>(defaultResponseFields));
      }

      if (query.getAggregations() == null || query.getAggregations().isEmpty()) {
         query.setAggregations(new LinkedList<>(defaultResponseAggregations));
      }
   }

}
